// Parts for my experiments with Wagners Hammer
// Details on:
// www.HomoFaciens.de

$fn=100;

M3_hole = 3.5;
M3_nut_e = 6.3;
M4_hole = 4.5;
M5_hole = 5.5;
M6_hole = 6.5;
M4_nut_e = 7.66 + 0.3;
M5_nut_e = 8.79 + 0.3;
M6_nut_e = 11.05 + 0.3;
M8_nut_e = 14.38+1.5;

bb3_di = 3;
bb3_do = 10.5;
bb3_h = 4;


bb5_di = 5.5;
bb5_do = 16.5;
bb5_h = 5;

// Mount screws CNC machine
m_screw_dis = 24;

if(1==0){
  translate([-13, 15, 7])
  difference(){
    cylinder(d=bb5_do, h=bb5_h, center=true);
    cylinder(d=bb5_di, h=bb5_h+0.1, center=true);
  }
}

//tube_holder_slide();
//translate([0, -38, 0])tube_clamps();
//electromagnet_air();
//electromagnet();
//tube_holder();
//spacer();
//fan_mount();
//compliant_mechanism();
//printer_mount();

//coin_holder();

//V3_tube_spacer(5);
//translate([15, 0, 0])V3_tube_spacer(20);
//V3_lower_guide();
//V3_CNC_mount();

//V_2_1_compliant_mechanism();

//V2_DC_motor_mount();

//V4_mount(); // Commercial lifting magnet

V5_mount(51); // DC Motor, simple

//V6_mount(); // DC motor with wire feeder


module V6_mount(){
  m_l = m_screw_dis + 94;
  m_w = 34;
  m_h = 6;
  
  // Wire tube
  wt_shift_Y = 4;
  wt_d = 0.5;
  wt_m_dis = 15;
  wt_m_X1 = -15;
  wt_m_X2 = -25;

  wt_m_X3 = 15;
  wt_m_X4 = 40;
  
  // Ball bearing
  bb_X = -28;
  bb_Y = wt_shift_Y-bb3_do/2;

  // DC motor
  mot_d = 35;
  mot_cut_d = 20;
  mot_arm_l = 70;
 
  // Wire tube clamps
  translate([-5, -25, 0])
  for(i=[0:1:2])
  translate([i*25, 0, 0])
  difference(){
    roundedRect([wt_m_dis+7, 7, 2], 3);
    translate([wt_m_dis/2, 0, 1])
    cylinder(d=M3_hole, h=3, center=true);
    translate([-wt_m_dis/2, 0, 1])
    cylinder(d=M3_hole, h=3, center=true);
  }
  // Wire tube clamps
  translate([-37, -35, 0])
  for(i=[0:1:1])
  translate([0, i*10, 0])
  difference(){
    roundedRect([wt_m_dis+22, 7, 2], 3);
    translate([wt_m_dis/2+6, 0, 1])
    cylinder(d=M3_hole, h=3, center=true);
    translate([-wt_m_dis/2+6, 0, 1])
    cylinder(d=M3_hole, h=3, center=true);
    translate([-wt_m_dis/2-7, 0, 1])
    cylinder(d=M3_hole, h=3, center=true);
  }
  
  
  // Main plate
  difference(){
    union(){
      roundedRect([m_l, m_w, m_h], 3);
      translate([bb_X+mot_arm_l, wt_shift_Y+mot_d/2, m_h/2])
      hull(){
        cylinder(d=M3_hole+10, h=m_h, center=true);
        translate([0, -20, 0])
        cylinder(d=M3_hole+10, h=m_h, center=true);
      }
      
    }
    // Mount holes CNC
    translate([m_l/2-7, 7-m_w/2, m_h/2]){
      cylinder(d=M6_hole, h=m_h+0.1, center=true);
      translate([-m_screw_dis, 0, 0])
      cylinder(d=M6_hole, h=m_h+0.1, center=true);
    }
    // Wire tube
    translate([0, wt_shift_Y, m_h])
    rotate([0, 90, 0])
    cylinder(d=wt_d, h=m_l+0.1, center=true);
    
    // Wire tube mount holes
    translate([bb_X, wt_shift_Y, m_h/2])
    for(m=[0:1:1])mirror([0,m,0]){
      translate([wt_m_X1, wt_m_dis/2, 0]){
        cylinder(d=M3_hole, h=m_h+0.1, center=true);
        hull(){
          translate([0, 0, -m_h/2])
          cylinder(d=M3_nut_e, h=4, center=true, $fn=6);
          cylinder(d=M3_hole, h=5, center=true);
        }
      }
      translate([wt_m_X2, wt_m_dis/2, 0]){
        cylinder(d=M3_hole, h=m_h+0.1, center=true);
        hull(){
          translate([0, 0, -m_h/2])
          cylinder(d=M3_nut_e, h=4, center=true, $fn=6);
          cylinder(d=M3_hole, h=5, center=true);
        }
      }

      translate([wt_m_X3, wt_m_dis/2, 0]){
        cylinder(d=M3_hole, h=m_h+0.1, center=true);
        hull(){
          translate([0, 0, -m_h/2])
          cylinder(d=M3_nut_e, h=4, center=true, $fn=6);
          cylinder(d=M3_hole, h=5, center=true);
        }
      }
      translate([wt_m_X4, wt_m_dis/2, 0]){
        cylinder(d=M3_hole, h=m_h+0.1, center=true);
        hull(){
          translate([0, 0, -m_h/2])
          cylinder(d=M3_nut_e, h=4, center=true, $fn=6);
          cylinder(d=M3_hole, h=5, center=true);
        }
      }
    }
    
    // Ball bearing
    translate([bb_X, bb_Y, m_h/2])
    cylinder(d=M3_hole, h=m_h+0.1, center=true);
    translate([bb_X, bb_Y, m_h])
    cylinder(d=M3_nut_e, h=bb3_h+4, center=true, $fn=6);
    translate([bb_X, bb_Y, m_h])
    cylinder(d=bb3_do+1, h=bb3_h+0.1, center=true);

    // Motor cut
    translate([bb_X, wt_shift_Y+mot_cut_d/2, m_h/2])
    cylinder(d=mot_cut_d+1, h=m_h+0.1, center=true);
    
    // Pivot point motor
    translate([bb_X+mot_arm_l, wt_shift_Y+mot_d/2, m_h/2])
    cylinder(d=M3_hole, h=m_h+0.1, center=true);
  }
  


  // Motor mount arm
  ma_l = mot_arm_l + mot_d/2 + 20;
  ma_w = 12;
  ma_h = 7;
  ma2_l = 60;
  ma2_w = 7;
  c_screw_dis = mot_d + 10;
 
  translate([-25, 52, 5])
  difference(){
    cylinder(d=15, h=10, center=true);
    cylinder(d=2, h=11, center=true);
  }

  translate([0, 35, 0])
  mirror([1,0,0])
  difference(){
    union(){
      roundedRect([ma_l, ma_w, ma_h], 3);
      translate([(ma2_l-ma_l)/2, 34, 0])
      roundedRect([ma2_l, ma2_w, ma_h], 3);
      //Pivot hole
      translate([mot_arm_l/2+10, 0, ma_h*1.5]){
        cylinder(d=ma_w, h=ma_h*3, center=true);
      }
    }
    translate([10, 0, 0]){
      //Pivot hole
      translate([mot_arm_l/2, 0, ma_h*1.5]){
        cylinder(d=M3_hole, h=ma_h*3+0.1, center=true);
        translate([0, 0, ma_h*1.5])
        cylinder(d=M3_nut_e, h=6, center=true, $fn=6);

        translate([0, 0, -ma_h*1.5])
        hull(){
          cylinder(d=M3_nut_e, h=6, center=true, $fn=6);
          cylinder(d=M3_hole, h=8, center=true);
        }
      }
      // Motor cut
      translate([-mot_arm_l/2, 16, ma_h/2])
      cylinder(d=mot_d, h=ma_h+0.1, center=true);
      
      // Rubber band hole
      translate([(10-c_screw_dis-mot_arm_l)/2, 0, ma_h/2])
      cylinder(d=M3_hole, h=100, center=true);

      // clamp screw holes
      translate([(c_screw_dis-mot_arm_l)/2, 0, ma_h/2])
      rotate([90, 0, 0])
      cylinder(d=M3_hole, h=100, center=true);
      translate([(-c_screw_dis-mot_arm_l)/2, 0, ma_h/2])
      rotate([90, 0, 0])
      cylinder(d=M3_hole, h=100, center=true);
    }
  }
  
  // Ball bearing arm
  bba_l = 72;
  bba_w = 12;
  bba_h = 6;
  bba_shift_X = -7;
  bba_shift_Y = -2;
  
  translate([-21, -47, 0])
  difference(){
    roundedRect([bba_l, bba_w, bba_h], 2);
    // Ball bearing
    translate([bba_shift_X, bba_shift_Y, m_h/2])
    cylinder(d=M3_hole, h=m_h+0.1, center=true);
    translate([bba_shift_X, bba_shift_Y, m_h])
    cylinder(d=M3_nut_e, h=bb3_h+4, center=true, $fn=6);
    translate([bba_shift_X, bba_shift_Y, m_h])
    cylinder(d=bb3_do+1, h=bb3_h+0.1, center=true);
    
    // Pivot point
    translate([bba_shift_X + wt_m_X2, bba_shift_Y, bba_h/2])
    cylinder(d=M3_hole, h=bba_h+0.1, center=true);
    translate([bba_shift_X + wt_m_X4, bba_shift_Y, bba_h/2])
    cylinder(d=M3_hole, h=bba_h+0.1, center=true);
  }
}

module V5_mount( mot_d = 25){
  m_l = m_screw_dis + 80;
  m_w = 14;
  m_h = 7;
  m2_l = mot_d+15;
  m2_w = 14;
  lever_l1 = 62;
  lever_l2 = 75;
  lever_a = 10;
  lever_Z = 20;
  
  // Motor shaft mount
  msm_d = 20;
  msm_h = 10;
  shaft_d = 6;
  
 
  // Motor shaft
  translate([0, 30, 0])
  difference(){
    roundedRect([msm_d, msm_d, msm_h], 2);
    translate([0, 0, msm_h/2])
    cylinder(d=shaft_d, h=msm_h+0.1, center=true);
    translate([5.2, 0, msm_h/2])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=msm_d+0.1, center=true);
    translate([-msm_d/2, 0, msm_h/2])
    rotate([0, 90, 0])
    cylinder(d=M3_hole, h=msm_d, center=true);
    
    translate([-6, 0, msm_h/2+1])
    cube(size=[3, 5.6, msm_h], center=true);
  }
  
  // Mount
  difference(){
    union(){
      roundedRect([m_l, m_w, m_h], 3, [0,1,0,1]);
      translate([(m2_l-m_l)/2, mot_d, 0])
      roundedRect([m2_l, m2_w, m_h], 3);
      translate([-m_l/2-m_w/2-3.5, lever_l2/2-m_w/2-1.5, 0])
      rotate([0, 0, lever_a])
      roundedRect([m_w, lever_l2, m_h], 3, [1,0,1,1]);
      translate([-m_l/2-16, lever_l1, lever_Z/2+2])
      cylinder(d=10, h=lever_Z, center=true);
    }
    // Mount holes CNC
    translate([m_l/2-7, 0, m_h/2]){
      cylinder(d=M6_hole, h=m_h+0.1, center=true);
      translate([-m_screw_dis, 0, 0])
      cylinder(d=M6_hole, h=m_h+0.1, center=true);
    }
    // Motor cut
    translate([7.5+mot_d/2-m_l/2, mot_d/2, m_h/2])
    cylinder(d=mot_d, h=m_h+0.1, center=true);
    
    // clamp screw holes
    translate([5-m_l/2, 0, m_h/2])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=150, center=true);
    translate([mot_d+10-m_l/2, 0, m_h/2])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=150, center=true);
    
    // spring cuts
    for(i=[-24:6:18])
    translate([i-7, 2-m_w/2, m_h/2])
    cylinder(d=1.5, h=m_h+0.1, center=true);
    
    // Wire guide
    translate([-m_l/2, lever_l1, lever_Z])
    rotate([0, 90, 0])
    cylinder(d=2.2, h=100, center=true);
  }
}

module V4_mount(){
  m_l = 90;
  m_w = 30;
  m_wall = 2;
  m_h = 10;
  m_shift = 50;
  mm_screw_dis = 15;
  
  difference(){
    union(){
      roundedRect([m_l, m_w, m_wall], 5);
      hull(){
        translate([0, 0, m_wall/2])
        cube(size=[m_l-20, m_wall, m_wall], center=true);
        translate([0, 0, m_h])
        cube(size=[m_l-60, m_wall, m_wall], center=true);
      }
    }
    
    for(i=[0:1:1])mirror([0,i,0]){
      // Mount holes on CNC
      translate([m_l/2-7, 7-m_w/2, m_wall/2])
      cylinder(d=M6_hole, h=m_wall+0.1, center=true);
      translate([m_l/2-7-m_screw_dis, 7-m_w/2, m_wall/2])
      cylinder(d=M6_hole, h=m_wall+0.1, center=true);
      
      // Mount holes electromagnet / water hose
      translate([-(m_l/2-7), m_w/2-7, m_wall/2])
      cylinder(d=M3_hole, h=m_wall+0.1, center=true);
      translate([mm_screw_dis-(m_l/2-7), m_w/2-7, m_wall/2])
      cylinder(d=M3_hole, h=m_wall+0.1, center=true);
    }

    
  }
  
}

module V2_DC_motor_mount(){
  mm_l = 70;
  mm_w = 10;
  mm_h = 15;
  mm_h2 = 25;
  mm_wall = 2;
  cut_e = 15;
  mm_shift_X = 30;
  for(i=[0:1:1])mirror([0,i,0])
  translate([0, -8, 0])
  difference(){
    union(){
      roundedRect([mm_l, mm_h, mm_w], 2);
      translate([mm_shift_X/2, -(mm_h2-mm_h)/2, 0])
      roundedRect([mm_l+mm_shift_X, mm_h2, mm_wall], 2);
    }
    // Center cut
    translate([0, mm_h/2, mm_w/2])
    rotate([0, 0, 45])
    cube(size=[cut_e, cut_e, mm_w+0.1], center=true);
    
    // Frame mount holes
    for(i=[5-mm_l/2:10:mm_l/2+mm_shift_X-5])
    translate([i, -12.5, mm_wall/2])
    cylinder(d=M3_hole, h=mm_wall+0.1, center=true);
    
    // Motor mount screws
    for(i=[-30:10:30])
    if(i!=0)
    translate([i, 0, mm_w/2+1])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=mm_h+0.1, center=true);
  }
}

module V_2_1_compliant_mechanism(){
  cm_l = 130;
  cm_w = 100;
  cm_h = 10;
  cm_shift = 0;
  cm_wall = 2;
  cm_wall_f = 10;
  cm_hinge = 0.7;
  cm_c_w = 10;
  cm_c_l1 = 60;
  cm_c_l2 = 90;
  cm_cut_l = 47;
  cm_cut_w = 2;
  
  mount_shift = 10;
  // Ferrite mount
  fm_w = 15;
  fm_shift =20;
  
  // Electromagnet mount
  m_l = cm_wall_f;
  m_w = 60;
  m_h = 35;
  m_wall = 2;
  
  // Electromagnet mounts
  for(m=[0:1:1])mirror([m,0,0])
  translate([105, 0, 5])
  rotate([0, -90, 0])
  difference(){
    translate([0, 0, m_h/2])
    cube(size=[m_l, m_w, m_h], center=true);
    difference(){
      translate([m_wall, 0, m_h/2+m_wall])
      cube(size=[m_l, m_w-2*m_wall, m_h], center=true);
      cube(size=[m_l+0.1, m_wall, m_h*2.1], center=true);
    }
    
    hull(){
      translate([cm_wall_f/2, 0, m_h/2+m_wall])
      cube(size=[0.1, cm_w + 0.1, m_h], center=true);
      translate([m_wall*2-cm_wall_f/2, 0, m_h])
      cube(size=[0.1, cm_w + 0.1, 0.1], center=true);
    }
    
    // Mount holes
    for(i=[-20:10:20])
    translate([0, i, m_wall/2]){
      if(i!=0){
        cylinder(d=M3_hole, h=cm_wall_f+0.1, center=true);
        translate([0, 0, m_h-cm_wall_f/2])
        rotate([0, 90, 0])
        cylinder(d=M3_hole, h=cm_wall_f+0.1, center=true);      
      }
    }
  }

  // Compliant frame
  if(1)
  difference(){
    union(){
      roundedRect([cm_l, cm_w, cm_h], 5);  
      translate([cm_shift, 0, 0])
      // CNC mounts
      for(i=[0:1:1])mirror([i,0,0])
      translate([m_screw_dis/2, cm_w/2+mount_shift, cm_h/2])
      hull(){
        cylinder(d=15, h=cm_h, center=true);
        translate([0, -mount_shift, 0])
        cylinder(d=15, h=cm_h, center=true);
      }
    }
    difference(){
      translate([0, 0, -0.05])
      roundedRect([cm_l-2*cm_wall_f, cm_w-2*cm_wall_f, cm_h+.1], 1);
      translate([cm_shift, 0, 0]){
        translate([0, 0, cm_h/2])
        cube(size=[cm_c_l2, cm_c_w, cm_h], center=true);
        // Arms
        for(i=[0:1:1])mirror([i,0,0])
        translate([cm_c_l1/2, 0, cm_h/2])
        cube(size=[cm_hinge, cm_w-2*cm_wall_f, cm_h], center=true);

        // Locking screw
        for(j=[0:1:1])mirror([j,0,0])mirror([0,j,0])
        translate([cm_c_l2/2-5, -5, cm_h/2])
        cube(size=[10, 12, cm_h], center=true);
        
        // Ferrite mount
        for(i=[0:1:1])mirror([i,0,0])
        translate([fm_shift, 0, cm_h/2])
        hull(){
          translate([0, -fm_w/2, 0])
          cylinder(d=10, h=cm_h, center=true);
          translate([0, fm_w/2, 0])
          cylinder(d=10, h=cm_h, center=true);
        }
      }      
    }

    // Ferrite mount
    for(i=[0:1:1])mirror([i,0,0]){
      translate([fm_shift, -fm_w/2, cm_h/2])
      cylinder(d=M3_hole, h=cm_h+0.1, center=true);
      translate([fm_shift, fm_w/2, cm_h/2])
      cylinder(d=M3_hole, h=cm_h+0.1, center=true);
    }

    // Locking screw
    for(j=[0:1:1])mirror([j,0,0])mirror([0,j,0]){
      translate([cm_c_l2/2-5, -7, cm_h/2+1])
      cube(size=[5.5, 3, cm_h], center=true);
      translate([cm_c_l2/2-5, -7, cm_h/2])
      rotate([90, 0, 0])
      cylinder(d=M3_hole, h=12, center=true);
    }

    // Springs
    translate([cm_shift, 0, 0])
    for(i=[0:1:1])mirror([i,0,0])
    for(j=[0:1:1])mirror([0,j,0])
    translate([cm_c_l1/2, 
               (cm_w-2*cm_wall_f+cm_cut_w)/2+cm_hinge,
               cm_h/2])
    cube(size=[cm_cut_l, cm_cut_w, cm_h+0.1], center=true);
    
    // Mount screws on Z axis
    translate([cm_shift, 0, 0])
    for(i=[0:1:1])mirror([i,0,0])
    translate([m_screw_dis/2, cm_w/2+mount_shift, cm_h/2])
    cylinder(d=M6_hole, h=cm_h+0.1, center=true);
    // Center axis hole
    translate([0, 0, cm_h/2])
    rotate([0, 90, 0])
    cylinder(d=M4_hole+0.4, h=cm_l+0.1, center=true);
    translate([cm_l/2, 0, cm_h/2])
    rotate([0, 90, 0])
    cylinder(d=6, h=cm_wall_f*2.1, center=true);
    // Electromagnet mount hole grid
    for(j=[0:1:1])mirror([j,0,0])
    translate([(cm_wall_f-cm_l)/2, 0, cm_h/2]){
      for(i=[-20:10:20])
      translate([0, i, 0]){
        if(i!=0)
        cylinder(d=M3_hole, h=cm_wall_f+0.1, center=true);      
        rotate([0, 90, 0])
        cylinder(d=M3_hole, h=cm_wall_f+0.1, center=true);      
      }
    }
    for(i=[0:1:1])mirror([0,i,0])
    translate([0, (cm_w-cm_c_w)/2, cm_h/2])
    cylinder(d=M3_hole, h=cm_h+0.1, center=true);
  }
}


module compliant_mechanism(){
  cm_l = 190;
  cm_w = 100;
  cm_h = 10;
  cm_shift = 30;
  cm_wall = 2;
  cm_wall_f = 10;
  cm_hinge = 0.7;
  cm_c_w = 10;
  cm_c_l = 60;
  cm_cut_l = 47;
  cm_cut_w = 2;
  

  difference(){
    union(){
      roundedRect([cm_l, cm_w, cm_h], 5);  
      translate([cm_shift, 0, 0])
      for(i=[0:1:1])mirror([i,0,0])
      translate([m_screw_dis/2, cm_w/2, cm_h/2])
      cylinder(d=15, h=cm_h, center=true);
    }
    difference(){
      translate([0, 0, -0.05])
      roundedRect([cm_l-2*cm_wall_f, cm_w-2*cm_wall_f, cm_h+.1], 1);
      translate([cm_shift, 0, 0]){
        translate([0, 0, cm_h/2])
        cube(size=[cm_c_l, cm_c_w, cm_h], center=true);
        // Arms
        for(i=[0:1:1])mirror([i,0,0])
        translate([cm_c_l/2, 0, cm_h/2])
        cube(size=[cm_hinge, cm_w-2*cm_wall_f, cm_h], center=true);
      }      
    }
    // Springs
    translate([cm_shift, 0, 0])
    for(i=[0:1:1])mirror([i,0,0])
    for(j=[0:1:1])mirror([0,j,0])
    translate([cm_c_l/2, 
               (cm_w-2*cm_wall_f+cm_cut_w)/2+cm_hinge,
               cm_h/2])
    cube(size=[cm_cut_l, cm_cut_w, cm_h+0.1], center=true);
    
    // Mount screws on Z axis
    translate([cm_shift, 0, 0])
    for(i=[0:1:1])mirror([i,0,0])
    translate([m_screw_dis/2, cm_w/2, cm_h/2])
    cylinder(d=M6_hole, h=cm_h+0.1, center=true);
    // Center axis hole
    translate([0, 0, cm_h/2])
    rotate([0, 90, 0])
    cylinder(d=M4_hole+0.4, h=cm_l+0.1, center=true);
    translate([cm_l/2, 0, cm_h/2])
    rotate([0, 90, 0])
    cylinder(d=6, h=cm_wall_f*2.1, center=true);
    // Electromagnet mount hole grid
    translate([(cm_wall_f-cm_l)/2, 0, cm_h/2]){
      for(i=[-20:10:20])
      translate([0, i, 0]){
        if(i!=0)
        cylinder(d=M3_hole, h=cm_wall_f+0.1, center=true);      
        rotate([0, 90, 0])
        cylinder(d=M3_hole, h=cm_wall_f+0.1, center=true);      
      }
    }
  }
}




module V3_CNC_mount(){
  cnc_l = 40;
  cnc_w = 20;
  cnc_h = 20;
  cnc_wall = 3;
  
  difference(){
    union(){
      roundedRect([cnc_l, cnc_w, cnc_wall], 5, [0,0,1,1]);
      translate([0, (cnc_wall-cnc_w)/2, cnc_h/2])
      rotate([90, 0, 0])
      roundedRect([cnc_l, cnc_h, cnc_wall], 5, [0,0,1,1]);
      // Enforcement
      hull(){
        translate([0, 0, cnc_wall/2])
        cube(size=[cnc_wall, cnc_w, cnc_wall], center=true);
        translate([0, -cnc_w/2, cnc_h/2])
        cube(size=[cnc_wall, cnc_wall, cnc_h], center=true);
      }
    }
    // CNC mount holes
    for(i=[0:1:1])mirror([i,0,0])
    translate([m_screw_dis/2, cnc_w/2-7, cnc_wall/2])
    cylinder(d=M6_hole, h=cnc_wall+0.1, center=true);
    // Hammer mount holes
    for(i=[0:1:1])mirror([i,0,0])
    translate([m_screw_dis/2, -cnc_w/2, cnc_h/2])
    rotate([90, 0, 0])
    cylinder(d2=M3_hole, d1=6, h=cnc_wall+0.1, center=true);
  }
  
  
}


module V3_lower_guide(){
  lg_l = 35;
  lg_w = 20;
  lg_h = 20;
  lg_wall = 2;
  screw_dis = 22;
  
  guide_h = 25;
  guide_cut = 18*0+3.5;
  
  tube_d = 4;
  
  if(0)
  difference(){
    union(){
      translate([0, 0, lg_wall/2])
      cube(size=[lg_l, lg_w, lg_wall], center=true);
      
      for(i=[0:1:1])mirror([i,0,0])
      translate([(lg_l-lg_wall)/2, 0, lg_h/2])
      cube(size=[lg_wall, lg_w, lg_h], center=true);
      // Mount points lower guide
      for(i=[0:1:1])mirror([i,0,0])
      translate([screw_dis/2, 0, 2])
      cylinder(d1=13, d2=8, h=4, center=true);  
    }
    // Mount holes on frame
    translate([0, 0, lg_h - 5])
    rotate([0, 90, 0])
    cylinder(d=M4_hole, h=lg_l+0.1, center=true);  
    
    // Mount holes lower guide
    for(i=[0:1:1])mirror([i,0,0]){
      translate([screw_dis/2, 0, lg_wall/2])
      cylinder(d=M3_hole, h=lg_wall+0.1, center=true);  
      translate([screw_dis/2, 0, 4])
      cylinder(d=M3_nut_e, h=6, center=true, $fn=6);  
    }
    
    // Center cole
    translate([0, 0, lg_wall/2])
    cylinder(d=10, h=lg_wall+0.1, center=true);  
  }
  
  translate([0, 22, 0])
  difference(){
    union(){
      translate([0, 0, lg_wall/2])
      cube(size=[lg_l, lg_w, lg_wall], center=true);
      
      
      translate([0, (lg_w-lg_wall)/2, guide_h/2])
      cube(size=[lg_l, lg_wall, guide_h], center=true);
    }
    //Guide cut
    translate([0, (lg_w-lg_wall)/2, lg_wall+guide_h/2+5])
    cube(size=[guide_cut, lg_wall+0.1, guide_h], center=true);
    

    // Center cole
    translate([0, 0, lg_wall/2])
    cylinder(d=tube_d*1.8, h=lg_wall+0.1, center=true, $fn=3);  

    // Mount holes lower guide
    for(i=[0:1:1])mirror([i,0,0]){
      translate([screw_dis/2, 0, lg_wall/2])
      cylinder(d=9, h=lg_wall+0.1, center=true);  
    }

    // Halfes cut
    translate([-1.2, -lg_wall, lg_wall/2])
    cube(size=[1.5, lg_w, lg_wall+0.1], center=true);

    // Bend cut
    translate([-lg_l/2-5, lg_w/2-3, lg_wall/2])
    cube(size=[lg_l, 2, lg_wall+0.1], center=true);

  }
//  translate([0, 22, 0])
//  cylinder(d=4, h=10, center=true);
}

module V3_tube_spacer(ts_h = 20){
  ts_do = 9.5;
  ts_di = 4.5;
  brim_d = 20;
  brim_h = 0.35;
  
  translate([0, 0, ts_h/2]){
    difference(){
      union(){
        cylinder(d=ts_do, h=ts_h, center=true);
        translate([0, 0, (brim_h-ts_h)/2])
        cylinder(d=brim_d, h=brim_h, center=true);
      }
      cylinder(d=ts_di, h=ts_h+0.1, center=true);
    }
  }
}

module coin_holder(){
  coin_d = 20.9;
  coin_h = 3.5;
  
  cm_l = 35;
  cm_w = 35;
  cm_h = 20;
  cm_wall = 2;
  cm_h_plus = 1;
  cm_flap = 30;
  screw_dis = 50;
  
  ref_x = coin_d/2+3;
  ref_y = coin_d/2+3;
  ref_z = 5;
  
  difference(){
    union(){
      roundedRect([cm_l+2*cm_flap, cm_w, cm_wall], 5);
      roundedRect([cm_l, cm_w, cm_h+cm_h_plus], 5);
      // reference marking
      intersection(){
        roundedRect([cm_l, cm_w, cm_h+cm_h_plus+ref_z], 5);
        translate([ref_x, ref_x, cm_h-1+ref_z/2])
        cylinder(d1=9, d2=3, h=ref_z, center=true);
      }
    }
    difference(){
      translate([0, 0, cm_h])
      roundedRect([cm_l-2*cm_wall, cm_w-2*cm_wall, cm_h], 4);
      // reference marking
      translate([ref_x, ref_x, cm_h-1+ref_z/2])
      cylinder(d1=9, d2=3, h=ref_z, center=true);
    }
    // Coin mount
    translate([0, 0, cm_h-coin_h/2])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=cm_w+0.1, center=true);
    for(i=[0:1:1])
    mirror([0,i,0])
    translate([0, coin_d/2+3.55, cm_h-coin_h/2]){
      cube(size=[5.5, 3, 7], center=true);
      cylinder(d=2, h=15, center=true);
    }
    //cable cuts
    translate([0, 0, cm_h/2-4])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=cm_w+0.1, center=true);
    translate([0, 0, cm_h/2+2])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=cm_w+0.1, center=true);
    // Coin
    translate([0, 0, cm_h - coin_h/2+0.1])
    cylinder(d=coin_d, h=coin_h, center=true);
    // Inner cylinder
    translate([0, 0, cm_h/2])
    cylinder(d=coin_d-5, h=cm_h+0.1, center=true);
    // reference marking
    translate([ref_x, ref_x, cm_h+ref_z-1])
    cylinder(d=1.0, h=2, center=true);
    // Mount screws
    for(i=[0:1:1])
    mirror([i,0,0])
    translate([screw_dis/2, 0, cm_wall/2])
    hull(){
      cylinder(d=M6_hole, h=cm_wall+0.1, center=true);
      translate([15, 0, 0])
      cylinder(d=M6_hole, h=cm_wall+0.1, center=true);
    }
  }
  
  
  
  
}


module printer_mount(){
  pm_l = 40;
  pm_w = 15;
  pm_h = 40;
  pm_wall = 2;
  mount_w = 15;
  mount_shift = -10;
  
  difference(){
    union(){
      roundedRect([pm_l, pm_w, pm_wall], 3);
      hull(){
        translate([mount_shift, (pm_w-pm_wall)/2, pm_h/2]){
          cube(size=[mount_w, pm_wall, pm_h], center=true);
        }
        translate([mount_shift, 0, pm_wall/2])
        cube(size=[pm_w, pm_w, pm_wall], center=true);
      }      
    }
    translate([mount_shift, -pm_wall, pm_wall+pm_h/2]){
      cube(size=[mount_w-2*pm_wall, pm_w, pm_h], center=true);
    }
    translate([mount_shift, 0, 10])
    rotate([90, 0, 0])
    cylinder(d=M5_hole, h=pm_w+1.1, center=true);
    translate([mount_shift, 0, 10+m_screw_dis])
    rotate([90, 0, 0])
    cylinder(d=M5_hole, h=pm_w+1.1, center=true);

  }
}

module fan_mount(){
  fm_l = 75;
  fm_w = 20;
  fm_wall = 2;
  fm_h = 20;
  screw_dis = 62;
  
  difference(){
    union(){
      roundedRect([fm_l, fm_w, fm_wall], 2);
      translate([-m_screw_dis/2, 5-fm_w/2, 0])
      roundedRect([15, 10, fm_h], 2);
    }
    for(i=[0:1:1])mirror([i,0,0])
    translate([screw_dis/2, 5, fm_wall/2])
    cylinder(d=M4_hole, h=fm_wall+0.1, center=true);
    translate([-m_screw_dis/2, 5-fm_w/2, fm_h/2])
    cylinder(d=M5_hole, h=fm_h+0.1, center=true);
    hull(){
      translate([-m_screw_dis/2, 5-fm_w/2, 0]){
        cylinder(d=M5_hole, h=25, center=true);
        cylinder(d=M5_nut_e, h=20, center=true, $fn=6);
      }
    }
      
  }
  
}

module electromagnet(){
  em_d = 45;
  em_wall = 2;
  em_cut_w = 13;
  em_cut_shift = 5;
  em_h = 25;
  
  translate([0, 0, em_wall/2])
  difference(){
    union(){
      cylinder(d=em_d, h=em_wall, center=true);
      translate([0, 0, (em_h-em_wall)/2])
      hull(){
        translate([-(em_d-em_cut_shift)/2, 0, 0])
        cube(size=[em_cut_shift,
                   em_cut_w + 2 * em_wall,
                   em_h], center=true);

        translate([(em_d-em_cut_shift)/2, 0, (em_wall-em_h)/2])
        cube(size=[em_cut_shift,
                   em_cut_w + 2 * em_wall,
                   em_wall], center=true);
      }
    }
    translate([em_cut_shift, 0, 0])
    cube(size=[em_d, em_cut_w, em_h * 2.1], center=true);
    // Long hole
    hull(){
      translate([0, 0, (em_h-em_wall)/2 + 7.5])
      rotate([0, 90, 0])
      cylinder(d=M3_hole, h=em_d + 0.1, center=true);
      translate([0, 0, (em_h-em_wall)/2 - 7.5])
      rotate([0, 90, 0])
      cylinder(d=M3_hole, h=em_d + 0.1, center=true);
    }
    
  }
}
module electromagnet_air(){
  e_di = 19;
  e_h = 19;
  e_wall = 1.4;
  e_wall_d = 2;
  e_do = e_di + 2 * e_wall;
  e_disc = 30;
  e_shift = 15;
  e_m_dis = 20;

  translate([-32, 0, 0])  
  difference(){
    translate([0, 0, e_wall_d/2])
    cylinder(d=e_disc, h=e_wall_d, center=true);
    translate([0, 0, e_h/2])
    cylinder(d=e_do, h=e_h+0.1, center=true);
    translate([e_disc/2, 0, 0])
    cube(size=[e_disc/2, 2, e_h], center=true);
    translate([e_disc/2, 0, 0])
    cube(size=[5, e_disc, e_h], center=true);
  }

  difference(){
    union(){
      translate([0, 0, e_wall_d/2])
      cylinder(d=e_disc, h=e_wall_d, center=true);
      translate([0, 0, e_h/2])
      cylinder(d=e_do, h=e_h, center=true);
      translate([e_shift/2, 0, 0])
      roundedRect([e_shift, e_disc-10, e_wall_d], 2, [0,0,0,0]);
      translate([e_shift, 0, 3])
      rotate([90, 0, 0])
      cylinder(d=6, h=e_disc-10, center=true);
      translate([e_shift, 0, 3 + 20])
      rotate([90, 0, 0])
      cylinder(d=6, h=e_disc-10, center=true);
      
      translate([e_shift, 0, 3 + 10])
      cube(size=[3, 20, e_disc-10], center=true);
    }
    translate([0, 0, e_h/2])
    cylinder(d=e_di, h=e_h+0.1, center=true);

    translate([0, 12.2, e_h/2])
    cylinder(d=2.5, h=e_h+0.1, center=true);    

    translate([e_shift, 0, 3])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=e_disc+0.1, center=true);

    translate([e_shift, 0, 3 + 20])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=e_disc+0.1, center=true);
  }
}

module tube_clamps(){
  tc_l = 25;
  tc_w = 17.5;
  tc_h = 8;
  tc_di = 4.2;
  tc_flap = 15;
  tc_wall = 2;
  tc_do = 20;
  
//  for(i=[0:1:1])mirror([0,i,0])
  translate([0, 15, tc_h/2])
  difference(){
    translate([0, -2, -tc_h/2])
    roundedRect([tc_w, tc_l, tc_h],2);

    cylinder(d=tc_di, h=tc_h+0.1, center=true);
    translate([0, 0, 1])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=tc_l+0.1, center=true);
    translate([0, 5, 1])
    cube(size=[6,3,tc_h], center=true);
  }

  translate([20, 15, tc_h/2])
  difference(){
    cylinder(d=tc_do, h=tc_h, center=true);
    cylinder(d=tc_di, h=tc_h+0.1, center=true);
    
    translate([0, 0, 1])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=tc_l+0.1, center=true);
    translate([0, 5, 1])
    cube(size=[6,3,tc_h], center=true);
  }

}

module tube_holder_slide(){
  ths_l = 80;
  ths_w = 50;
  ths_wall = 2;
  ths_h = 20;
  slide_w = 20;
  slide_shift = 5;
  adjust_dis = 30;
  adjust_edge = 5;
  adjust_w = 5;
  adjust_h = 2;
  
  for(j=[0:1:1])mirror([j,0,0])
  translate([ths_l/2 + 5, 0, 0])
  difference(){
    hull(){
      for(i=[0:1:1])mirror([0,i,0])
      translate([0, adjust_dis/2, adjust_h/2])
      cylinder(d=7, h=adjust_h, center=true);
    }
    for(i=[0:1:1])mirror([0,i,0])
    translate([0, adjust_dis/2, adjust_h/2])
    cylinder(d=M3_hole, h=adjust_h+0.1, center=true);
  }
  
  difference(){
    union(){
      roundedRect([ths_l, ths_w, ths_wall], 5);
      for(i=[0:1:1])mirror([i,0,0]){
        translate([(ths_l-ths_wall)/2, slide_shift, ths_h/2])
        cube(size=[ths_wall, slide_w, ths_h], center=true);
        translate([0, slide_shift, 0])
        for(j=[0:1:1])mirror([0,j,0])
        translate([(ths_l-slide_w)/2, slide_w/2, ths_h/2])
        cube(size=[slide_w, ths_wall, ths_h], center=true);
      }
    }
    // Electromagnet mount screws
    for(i=[0:1:1])mirror([i,0,0])
    translate([10, ths_w/2-5, 0])
    cylinder(d=M3_hole, h=ths_wall*2.1, center=true);
    
    // adjust screw distance
    translate([0, slide_shift, 0]){
      for(i=[0:1:1])mirror([i,0,0])
      for(j=[0:1:1])mirror([0,j,0])
      translate([ths_l/2-adjust_edge, adjust_dis/2, 0])
      cylinder(d=M3_hole, h=ths_wall*2.1, center=true);
    }
    // Mount screws on Z axis
    translate([m_screw_dis/2, -(ths_w/2-7), ths_wall/2])
    cylinder(d=M6_hole, h=ths_wall+0.1, center=true);
    translate([-m_screw_dis/2, -(ths_w/2-7), ths_wall/2])
    cylinder(d=M6_hole, h=ths_wall+0.1, center=true);
    // square tube cut
    translate([0, slide_shift, ths_h])
    rotate([45, 0, 0])
    cube(size=[ths_l+0.1, 5, 5], center=true);
  }
}

module tube_holder(){
  bb_dis = 40;
  bb_edge = 7;
  bb_shift_X = 7;
  th_l = bb_dis + 30;
  th_w = 45;
  th_wall = 2;
  
  // Bal bearing spring
  bbs_wall = 2;
  bbs_l = bb_dis+10;
  bbs_w = 9;
  bbs_h = 2;
  bbs_cut_X = 10;
  bbs_cut_w = 10;
  
  translate([bb_shift_X, 30, 0*5]){
    difference(){
      union(){
        roundedRect([bbs_l, bbs_w, bbs_h], bbs_w/2);
        for(i=[0:1:1])mirror([i,0,0])
        translate([bb_dis/2, 0, bbs_h/2+1])
        cylinder(d=M5_hole + 3, h=bbs_h, center=true);
        
      }
      for(i=[0:1:1])mirror([i,0,0])
      translate([bbs_cut_X, bbs_wall, -0.05])
      roundedRect([bbs_cut_w, bbs_w, bbs_h+0.1], 2, [1,1,0,0]);
      cylinder(d=M5_hole, h=bbs_h*2.1, center=true);
      for(i=[0:1:1])mirror([i,0,0])
      translate([bb_dis/2, 0, 0])
      cylinder(d=M5_hole, h=bbs_h*3.1, center=true);
    }
  }
  
  difference(){
    roundedRect([th_l, th_w, th_wall], 5);
    // Mount screws on Z axis
    translate([bb_shift_X+m_screw_dis/2, -(th_w/2-bb_edge), th_wall/2])
    cylinder(d=M6_hole, h=th_wall+0.1, center=true);
    translate([bb_shift_X-m_screw_dis/2, -(th_w/2-bb_edge), th_wall/2])
    cylinder(d=M6_hole, h=th_wall+0.1, center=true);

    translate([bb_shift_X+bb_dis/2, th_w/2-bb_edge, th_wall/2])
    cylinder(d=M5_hole, h=th_wall+0.1, center=true);
    translate([bb_shift_X-bb_dis/2, th_w/2-bb_edge, th_wall/2])
    cylinder(d=M5_hole, h=th_wall+0.1, center=true);
    translate([bb_shift_X, -(th_w/2-bb_edge), th_wall/2])
    hull(){
      cylinder(d=M5_hole, h=th_wall+0.1, center=true);
      translate([0, 15, 0])
      cylinder(d=M5_hole, h=th_wall+0.1, center=true);
    }
    translate([7-th_l/2, 0, th_wall/2])
    hull(){
      translate([0, 15, 0])
      cylinder(d=M3_hole, h=th_wall+0.1, center=true);
      translate([0, -15, 0])
      cylinder(d=M3_hole, h=th_wall+0.1, center=true);
    }
  }
  
}

module spacer(){
  s_do = 12;
  s_do2 = 8.5;
  s_di = 5.5;
  s_h1 = 1;
  s_h2 = 1.5;
  
  translate([0, 0, s_h1/2]){
    difference(){
      union(){
        cylinder(d=s_do, h=s_h1, center=true);
        translate([0, 0, (s_h2-s_h1)/2])
        cylinder(d=s_do2, h=s_h2, center=true);
      }
      cylinder(d=s_di, h=s_h2 * 2.1, center=true);
    }
  }  
}



module roundedRect(size, radius, edges=[1, 1, 1, 1], vscale=[1,1], shift=0){
  x = size[0];
  y = size[1];
  z = size[2];

  translate([0, -shift*2, 0]){
    linear_extrude(height=z, scale=[vscale[0], vscale[1]]){
      translate([0, shift*2, 0]){
        hull(){
            // place 4 circles in the corners, with the given radius
            if(edges[0]){
              translate([(-x/2)+(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
            if(edges[1]){
              translate([(x/2)-(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[2]){
              translate([(-x/2)+(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[3]){
              translate([(x/2)-(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
          }
       }
    }
  }
}